package com.google.code.fastbuilder;

import com.google.code.fastbuilder.internal.*;
import com.google.code.fastbuilder.internal.bytecode.*;
import com.google.code.fastbuilder.internal.spec.*;

public class BuilderFactory {

	public static final BuilderProvider BYTECODE_BUILDER_PROVIDER = new BytecodeBuilderProvider();

	public static <T, V extends IBuilder<T>> V make(final Class<V> spec) {
		return make(spec, SimpleSetterBuilderSpecification.INSTANCE);
	}

	public static <T, V extends IBuilder<T>> V make(final Class<V> spec, final BuilderSpecification builderSpec) {
		return BYTECODE_BUILDER_PROVIDER.make(spec, builderSpec);
	}
}
