package com.google.code.fastbuilder.util;

import java.lang.reflect.*;

public class Types {

	private Types() {
	}

	public static Class<?> getTypeArgumentOfInterface(Class<?> targetClass, Class<?> interfaceClass) {
		Type[] types = targetClass.getGenericInterfaces();

		for (Type type : types) {
			if (interfaceClass == type || type instanceof ParameterizedType) {
				ParameterizedType parameterizedType = (ParameterizedType) type;
				Type[] typeArguments = parameterizedType.getActualTypeArguments();
				if (typeArguments.length != 1) {
					throw new IllegalArgumentException("ParameterizedType [" + parameterizedType + "] cannot have more than one type argument");
				}
				return (Class<?>) typeArguments[0];
			}
		}

		return null;
	}
}
